config/routes.rb
# frozen_string_literal: true

Rails.application.routes.draw do
  resources :tenants
  resources :users

  resources :properties
  get 'advertised', to: 'properties#advertised_properties'

  resources :landlords

  resources :tenancies
  get 'due_this_month', to: 'tenancies#due_this_month'

  controller :sessions do
    get 'login' => :new, as: :login
    post 'login' => :create
    delete 'logout' => :destroy, as: :logout
  end

  root 'sessions#new'
  # For details on the DSL available within this file, see https://guides.rubyonrails.org/routing.html
end

app/models/landlord.rb
class Landlord < ApplicationRecord
  FIRST_NAME_MAX_LENGTH = 100
  LAST_NAME_MAX_LENGTH = 100
  EMAIL_MAX_LENGTH = 200

  # rubocop:disable Layout/LineLength
  EMAIL_REGEX = /\A([a-z0-9\+_\-\']+)(\.[a-z0-9\+_\-\']+)*@([a-z0-9\-]+\.)+[a-z]{2,6}\z/ix.freeze
  # rubocop:enable Layout/LineLength

  validates :first_name, presence: true
  validates :first_name, length: { maximum: FIRST_NAME_MAX_LENGTH,
                                  if: :first_name }

  validates :last_name, presence: true
  validates :last_name, length: { maximum: LAST_NAME_MAX_LENGTH,
                                  if: :last_name }

  validates :email, presence: true
  validates :email, uniqueness: { case_sensitive: false }
  validates :email, length: { maximum: EMAIL_MAX_LENGTH,
                              if: :email }
  validates :email, format: { with: EMAIL_REGEX },
                              if: -> { errors[:email].blank? }

  has_many :landlords_properties
  has_many :properties, through: :landlords_properties

  before_destroy :destroy_related_properties

  def destroy_related_properties
    properties_to_delete = properties
    co_owned_property_ids = co_owned_properties.pluck(:id)

    if co_owned_property_ids.any?
      # 1. Delete only association for the landlord to the property.
      landlords_properties.where(property_id: co_owned_property_ids).destroy_all

      # 2. Pick property where deleted landlord is the only one.
      properties_to_delete = properties_to_delete.where.not(id: co_owned_property_ids)
    end

    # Delete properties where deleted landlord is the only one.
    if properties_to_delete
      properties_to_delete.destroy_all
    end
  end

  def co_owned_properties
    properties.joins(:landlords).where.not(landlords: {id: self.id}).distinct
  end
end

app/controllers/landlords_controller.rb
class LandlordsController < ApplicationController
	before_action :set_landlord, only: %i[show edit update destroy]

	def index
    @landlords = Landlord.all
  end

  def show; end

  def new
    @landlord = Landlord.new
  end

  def edit; end

  def create
    @landlord = Landlord.new(landlord_params)
    if @landlord.save
      flash[:success] = 'Landlord was successfully created.'
      redirect_to @landlord
    else
      render :new, status: :unprocessable_entity
    end
  end

  def update
    if @landlord.update(landlord_params)
      flash[:success] = 'Landlord was successfully updated.'
      redirect_to @landlord
    else
      render :edit, status: :unprocessable_entity
    end
  end

  def destroy
    @landlord.destroy

    redirect_to landlords_url, notice: 'Landlord was successfully destroyed.'
  end

  private

  def set_landlord
    @landlord = Landlord.find(params[:id])
  end

  def landlord_params
    params.require(:landlord).permit(
      :first_name,
      :last_name,
      :email,
      property_ids: []
    )
  end
end

app/views/landlords/_form.html.erb
<%= form_with(model: landlord, local: true) do |form| %>
  <div class="field">
    <%= form.label :first_name %>

    <%= form.text_field :first_name %>

    <% if landlord.errors[:first_name] %>
      <% landlord.errors[:first_name].each do |message| %>
        <p class="errorMessage">
          <%= message %>
        </p>
      <% end %>
    <% end %>
  </div>

  <div class="field">
    <%= form.label :last_name %>

    <%= form.text_field :last_name %>

    <% if landlord.errors[:last_name] %>
      <% landlord.errors[:last_name].each do |message| %>
        <p class="errorMessage">
          <%= message %>
        </p>
      <% end %>
    <% end %>
  </div>

  <div class="field">
    <%= form.label :email %>

    <%= form.text_field :email %>

    <% if landlord.errors[:email] %>
      <% landlord.errors[:email].each do |message| %>
        <p class="errorMessage">
          <%= message %>
        </p>
      <% end %>
    <% end %>
  </div>


  <div class="actions">
    <% if landlord.persisted? %>
      <button type="submit" name="commit" class="addButton">
        <i class="fa fa-floppy-o" aria-hidden="true"></i>Update Landlord
      </button>

      <%= link_to '<i class="fa fa-times-circle" aria-hidden="true"></i>Cancel'.html_safe, landlord, class: "destroyButton" %>
    <% else %>
      <button type="submit" name="commit" class="addButton">
        <i class="fa fa-floppy-o" aria-hidden="true"></i>Create Landlord
      </button>
      <%= link_to '<i class="fa fa-times-circle" aria-hidden="true"></i>Cancel'.html_safe, landlords_path, class: "destroyButton" %>
    <% end %>
  </div>
<% end %>

app/views/landlords/edit.html.erb
<section class='scaffold'>
  <h2 class="breadcrumbs">
    <%= link_to "Landlords", landlords_path %>
    <i class="fa fa-long-arrow-right" aria-hidden="true"></i>
    <%= link_to "#{@landlord.first_name+" "+@landlord.last_name}", @landlord %>
    <i class="fa fa-long-arrow-right" aria-hidden="true"></i>
    Edit
  </h2>

    <%= render "form", landlord: @landlord %>
</section>

app/views/landlords/index.html.erb
<section class='scaffold'>
  <h2 class="breadcrumbs">Landlords</h2>

  <p>
    <%= link_to '<i class="fa fa-plus-circle" aria-hidden="true"></i>New Landlord'.html_safe, new_landlord_path, class: "addButton" %>
  </p>

  <table class="scaffoldListTable">
    <thead>
      <tr>
        <th>First Name</th>
        <th>Last Name</th>
        <th>email</th>
        <th colspan="3">Actions</th>
      </tr>
    </thead>

    <tbody>
      <% @landlords.each do |landlord| %>
        <tr>
          <td><%= link_to landlord.first_name, landlord %></td>
          <td><%= link_to landlord.last_name, landlord %></td>
          <td><%= link_to landlord.email, landlord %></td>
          <td><%= link_to 'view', landlord %></td>
          <td><%= link_to '<i class="fa fa-pencil" aria-hidden="true"></i>'.html_safe, edit_landlord_path(landlord), title: "Edit Landlord" %></td>
          <td><%= link_to '<i class="fa fa-trash" aria-hidden="true"></i>'.html_safe, landlord, method: :delete, data: { confirm: "Are you sure want to delete #{landlord.first_name+" "+landlord.last_name}?" }, title: "Delete Landlord" %></td>
        </tr>
      <% end %>
    </tbody>
  </table>
</section>

app/views/landlords/new.html.erb
<section class='scaffold'>
  <h2 class="breadcrumbs">
    <%= link_to "Landlords", landlords_path %>
    <i class="fa fa-long-arrow-right" aria-hidden="true"></i>
    New Landlord
  </h2>

    <%= render "form", landlord: @landlord %>
</section>

app/views/landlords/show.html.erb
<section class='scaffold'>
  <h2 class="breadcrumbs">
    <%= link_to "Landlords", landlords_path %>
    <i class="fa fa-long-arrow-right" aria-hidden="true"></i>
    <%= @landlord.first_name + " " +@landlord.last_name %>
  </h2>

  <p>
    <%= link_to '<i class="fa fa-plus-circle" aria-hidden="true"></i>New Landlord'.html_safe, new_landlord_path, class: "addButton" %>
  </p>

  <table class="scaffoldDataTable">
    <tbody>
      <tr>
        <th>LandLord Name</th>

        <th>Landlord Email</th>

        <th>Created</th>

        <th>Last Updated</th>
      </tr>

      <tr>
        <td><%= @landlord.first_name + " " +@landlord.last_name %></td>

        <td><%= @landlord.email %></td>

        <td><%= @landlord.created_at.strftime("%H:%M:%S %A %d %B %Y") %></td>

        <td><%= @landlord.updated_at.strftime("%H:%M:%S %A %d %B %Y") %></td>
      </tr>

      <% if @landlord.properties.any? %>
        <tr>
          <th>Property Name</th>

          <th>Property Address</th>
        </tr>
        <% @landlord.properties.each do |property| %>
          <tr>
            <td><%= link_to property.property_name, property %></td>
            <td><%= property.property_address %></td>
          </tr>
        <% end %>
      <% else %>
      <p> No properties owned by the landlord.
      <% end %>
    </tbody>
  </table>

  <p>
    <%= link_to '<i class="fa fa-pencil" aria-hidden="true"></i>Edit Landlord'.html_safe, edit_landlord_path(@landlord), class: "defaultButton" %>
  </p>
</section>